#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__) || defined(__DragonFly__) || defined(__APPLE__)
#if defined(__i386__)

/*
 * Use FreeBSD/NetBSD system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4         7
#define SYS_kill         37
#define SYS_execve       59

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         90
#define SYS_pipe2       542

#define SYS_sigaction   416
#define SYS_sigprocmask 340 /* 48? */

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_sbrk         69
#define SYS_getcwd      326

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	mov	$SYS_exit, %eax
	jmp	_syscall

	.globl	__fork
	.type	__fork, @function
__fork:
	mov	$SYS_fork, %eax
	jmp	_syscall

	.globl	__wait4
	.type	__wait4, @function
__wait4:
	mov	$SYS_wait4, %eax
	jmp	_syscall

	.globl	__kill
	.type	__kill, @function
__kill:
	mov	$SYS_kill, %eax
	jmp	_syscall

	.globl	__execve
	.type	__execve, @function
__execve:
	mov	$SYS_execve, %eax
	jmp	_syscall

	.globl	__read
	.type	__read, @function
__read:
	mov	$SYS_read, %eax
	jmp	_syscall

	.globl	__write
	.type	__write, @function
__write:
	mov	$SYS_write, %eax
	jmp	_syscall

	.globl	__open
	.type	__open, @function
__open:
	mov	$SYS_open, %eax
	jmp	_syscall

	.globl	__close
	.type	__close, @function
__close:
	mov	$SYS_close, %eax
	jmp	_syscall

	.globl	__dup
	.type	__dup, @function
__dup:
	mov	$SYS_dup, %eax
	jmp	_syscall

	.globl	__pipe
	.type	__pipe, @function
__pipe:
	mov	$SYS_pipe, %eax
	jmp	_syscall

	.globl	__dup2
	.type	__dup2, @function
__dup2:
	mov	$SYS_dup2, %eax
	jmp	_syscall

	.globl	__pipe2
	.type	__pipe2, @function
__pipe2:
	mov	$SYS_pipe2, %eax
	jmp	_syscall

	.globl	__sigaction
	.type	__sigaction, @function
__sigaction:
	mov	$SYS_sigaction, %eax
	jmp	_syscall

	.globl	__sigprocmask
	.type	__sigprocmask, @function
__sigprocmask:
	mov	$SYS_sigprocmask, %eax
	jmp	_syscall

	.globl	__chdir
	.type	__chdir, @function
__chdir:
	mov	$SYS_chdir, %eax
	jmp	_syscall

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	mov	$SYS_ioctl, %eax
	jmp	_syscall

	.globl	__sbrk
	.type	__sbrk, @function
__sbrk:
	mov	$SYS_sbrk, %eax
	jmp	_syscall

	.globl	____getcwd
	.type	____getcwd, @function
____getcwd:
	mov	$SYS_getcwd, %eax
	jmp	_syscall

_syscall:
	int	$0x80
	jnc	ret
err:	push	%eax
	call	_set_errno
	add	$0x4, %esp
ret:	ret
#endif
#endif
