#if defined(__linux__)
#if defined(__PPC__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       317

#define SYS_sigaction    67 /* rt_sigaction is 173 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 174 */

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getcwd      182

	.section .text

	.globl	___exit
	.type	___exit, %function
___exit:
	li	%r0, SYS_exit
	b	_syscall

	.globl	__fork
	.type	__fork, %function
__fork:
	li	%r0, SYS_fork
	b	_syscall

	.globl	__wait4
	.type	__wait4, %function
__wait4:
	li	%r0, SYS_wait4
	b	_syscall

	.globl	__kill
	.type	__kill, %function
__kill:
	li	%r0, SYS_kill
	b	_syscall

	.globl	__execve
	.type	__execve, %function
__execve:
	li	%r0, SYS_execve
	b	_syscall

	.globl	__read
	.type	__read, %function
__read:
	li	%r0, SYS_read
	b	_syscall

	.globl	__write
	.type	__write, %function
__write:
	li	%r0, SYS_write
	b	_syscall

	.globl	__open
	.type	__open, %function
__open:
	li	%r0, SYS_open
	b	_syscall

	.globl	__close
	.type	__close, %function
__close:
	li	%r0, SYS_close
	b	_syscall

	.globl	__dup
	.type	__dup, %function
__dup:
	li	%r0, SYS_dup
	b	_syscall

	.globl	__pipe
	.type	__pipe, %function
__pipe:
	li	%r0, SYS_pipe
	b	_syscall

	.globl	__dup2
	.type	__dup2, %function
__dup2:
	li	%r0, SYS_dup2
	b	_syscall

	.globl	__pipe2
	.type	__pipe2, %function
__pipe2:
	li	%r0, SYS_pipe2
	b	_syscall

	.globl	__sigaction
	.type	__sigaction, %function
__sigaction:
	li	%r0, SYS_sigaction
	b	_syscall

	.globl	__sigprocmask
	.type	__sigprocmask, %function
__sigprocmask:
	li	%r0, SYS_sigprocmask
	b	_syscall

	.globl	__chdir
	.type	__chdir, %function
__chdir:
	li	%r0, SYS_chdir
	b	_syscall

	.globl	__ioctl
	.type	__ioctl, %function
__ioctl:
	li	%r0, SYS_ioctl
	b	_syscall

	.globl	__brk
	.type	__brk, %function
__brk:
	li	%r0, SYS_brk
	b	_syscall

	.globl	____getcwd
	.type	____getcwd, %function
____getcwd:
	li	%r0, SYS_getcwd
	b	_syscall

_syscall:
	sc
	bc	4, 3, ret
err:	neg	%r3, %r3
ret:	blr
#endif
#endif
